/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


/***************************************************************************/
void save_options()
{
	int tint, tint2, tint3;
	char tstring[250], *tstringpointer;
	FILE *outfile;
	extern GtkWidget *enable_top_check, *enable_bottom_check;
    	extern GtkWidget *enable_ch_check, *enable_cl_check, *enable_ld_check;
    	extern GtkWidget *enable_lc_check, *enable_nc_check, *enable_date_check;
    	extern GtkWidget *enable_open_check, *enable_high_check, *enable_low_check;
    	extern GtkWidget *enable_close_check, *enable_volume_check, *enable_openi_check;
    	extern GtkWidget *bars_value_entry;
	extern int date_flag, open_flag, high_flag, low_flag, close_flag, volume_flag, openi_flag;
	extern int top_enable_flag, bottom_enable_flag, contract_high_flag, bars;
	extern int contract_low_flag, last_date_flag, last_close_flag, net_change_flag;
	extern char *config_file, *error_message, *last_group, invalid_entry[];
	extern display_message(), show_data_bar(), hide_data_bar(), create_config();
	extern show_info_bar(), hide_info_bar(), exit_edit_options_window(), update_stats_bar();
	
	
	outfile = fopen(config_file, "r+b");
	if (! outfile)
	{
		create_config();
		outfile = fopen(config_file, "r+b");
	}
	strncpy(tstring, last_group, 249);
	fwrite(tstring, 250, 1, outfile);
	tstringpointer = gtk_entry_get_text(GTK_ENTRY(bars_value_entry));
	if (tstringpointer == NULL)
	{
		bars = 500;
		fwrite(&bars, sizeof(int), 1, outfile);
	}
	else
	{
		sscanf(tstringpointer, "%s", tstring);
		tint = strlen(tstring);
		for (tint2 = 0; tint2 < tint; tint2++)
		{
			tint3 = isdigit(tstring[tint2]);
			if (tint3 == 0)
			{
				error_message = invalid_entry;
				display_message();
				fclose(outfile);
				return;
			}
		}
		bars = atoi(tstring);
		fwrite(&bars, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_top_check)->active)
	{
		if (top_enable_flag == 0)
			show_info_bar();
		top_enable_flag = 1;
		fwrite(&top_enable_flag, sizeof(int), 1, outfile);
	}
	else
	{
		if (top_enable_flag)
			hide_info_bar();
		top_enable_flag = 0;
		fwrite(&top_enable_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_bottom_check)->active)
	{
		if (bottom_enable_flag == 0)
			show_data_bar();
		bottom_enable_flag = 1;
		fwrite(&bottom_enable_flag, sizeof(int), 1, outfile);
	}
	else
	{
		if (bottom_enable_flag == 1)
			hide_data_bar();
		bottom_enable_flag = 0;
		fwrite(&bottom_enable_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_ch_check)->active)
	{
		contract_high_flag = 1;
		fwrite(&contract_high_flag, sizeof(int), 1, outfile);
	}
	else
	{
		contract_high_flag = 0;
		fwrite(&contract_high_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_cl_check)->active)
	{
		contract_low_flag = 1;
		fwrite(&contract_low_flag, sizeof(int), 1, outfile);
	}
	else
	{
		contract_low_flag = 0;
		fwrite(&contract_low_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_ld_check)->active)
	{
		last_date_flag = 1;
		fwrite(&last_date_flag, sizeof(int), 1, outfile);
	}
	else
	{
		last_date_flag = 0;
		fwrite(&last_date_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_lc_check)->active)
	{
		last_close_flag = 1;
		fwrite(&last_close_flag, sizeof(int), 1, outfile);
	}
	else
	{
		last_close_flag = 0;
		fwrite(&last_close_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_nc_check)->active)
	{
		net_change_flag = 1;
		fwrite(&net_change_flag, sizeof(int), 1, outfile);
	}
	else
	{
		net_change_flag = 0;
		fwrite(&net_change_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_date_check)->active)
	{
		date_flag = 1;
		fwrite(&date_flag, sizeof(int), 1, outfile);
	}
	else
	{
		date_flag = 0;
		fwrite(&date_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_open_check)->active)
	{
		open_flag = 1;
		fwrite(&open_flag, sizeof(int), 1, outfile);
	}
	else
	{
		open_flag = 0;
		fwrite(&open_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_high_check)->active)
	{
		high_flag = 1;
		fwrite(&high_flag, sizeof(int), 1, outfile);
	}
	else
	{
		high_flag = 0;
		fwrite(&high_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_low_check)->active)
	{
		low_flag = 1;
		fwrite(&low_flag, sizeof(int), 1, outfile);
	}
	else
	{
		low_flag = 0;
		fwrite(&low_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_close_check)->active)
	{
		close_flag = 1;
		fwrite(&close_flag, sizeof(int), 1, outfile);
	}
	else
	{
		close_flag = 0;
		fwrite(&close_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_volume_check)->active)
	{
		volume_flag = 1;
		fwrite(&volume_flag, sizeof(int), 1, outfile);
	}
	else
	{
		volume_flag = 0;
		fwrite(&volume_flag, sizeof(int), 1, outfile);
	}
	if (GTK_TOGGLE_BUTTON(enable_openi_check)->active)
	{
		openi_flag = 1;
		fwrite(&openi_flag, sizeof(int), 1, outfile);
	}
	else
	{
		openi_flag = 0;
		fwrite(&openi_flag, sizeof(int), 1, outfile);
	}
	fclose(outfile);
	exit_edit_options_window();
	update_stats_bar();
}
/*****************************************************************************/
void edit_options()
{
	char tstring[25];
	GtkWidget *frame, *frame2, *frame3, *frame4, *hbox, *hbox2;
    	GtkWidget *notebook, *ok_button, *cancel_button, *nbox, *label, *label2, *help_button;
    	GtkWidget *vbox, *vbox2, *vbox3, *vbox4, *vbox5, *vbox6;
    	extern GtkWidget *edit_options_window, *enable_top_check, *enable_bottom_check;
    	extern GtkWidget *enable_ch_check, *enable_cl_check, *enable_ld_check;
    	extern GtkWidget *enable_lc_check, *enable_nc_check, *enable_date_check;
    	extern GtkWidget *enable_open_check, *enable_high_check, *enable_low_check;
    	extern GtkWidget *enable_close_check, *enable_volume_check, *enable_openi_check;
    	extern GtkWidget *bars_value_entry;
    	extern exit_edit_options_window(), help_edit_options_window();
	extern int date_flag, open_flag, high_flag, low_flag, close_flag, volume_flag, openi_flag;
	extern int top_enable_flag, bottom_enable_flag, contract_high_flag, bars;
	extern int contract_low_flag, last_date_flag, last_close_flag, net_change_flag;
	extern int edit_options_flag;
    
	
        if (edit_options_flag)
        	return;
        edit_options_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        gtk_signal_connect (GTK_OBJECT (edit_options_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_edit_options_window), NULL);
	gtk_signal_connect (GTK_OBJECT (edit_options_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_edit_options_window), NULL);
        gtk_window_set_title (GTK_WINDOW (edit_options_window), "Edit Options");
        gtk_container_border_width (GTK_CONTAINER (edit_options_window), 0);
        gtk_window_position(GTK_WINDOW (edit_options_window), GTK_WIN_POS_CENTER);
	gtk_widget_set_usize(GTK_WIDGET (edit_options_window), 0, 0);
	
	nbox = gtk_hbox_new (FALSE, 10);
        gtk_container_add (GTK_CONTAINER (edit_options_window), nbox);
        gtk_container_border_width (GTK_CONTAINER (nbox), 10);
        gtk_widget_show (nbox);

	notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
     	gtk_box_pack_start (GTK_BOX (nbox), notebook, TRUE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (notebook), 0);
      	gtk_widget_show(notebook);
      	
      	vbox = gtk_vbutton_box_new ();
      	gtk_vbutton_box_set_spacing_default(5);
      	gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
      	gtk_box_pack_start (GTK_BOX (nbox), vbox, FALSE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 5);
      	gtk_widget_show (vbox);
      	
      	ok_button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (vbox), ok_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
			    GTK_SIGNAL_FUNC (save_options), NULL);
	gtk_widget_show (ok_button);
      	
      	cancel_button = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (vbox), cancel_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_edit_options_window), NULL);
      	gtk_widget_show (cancel_button);
      	
      	help_button = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (vbox), help_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    GTK_SIGNAL_FUNC (help_edit_options_window), NULL);
      	gtk_widget_show (help_button);
      	
      	/*** status page ***/
      	
      	vbox2 = gtk_vbox_new (FALSE, 10);
        gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
        gtk_widget_show (vbox2);
        
        frame = gtk_frame_new("Enable Status Bars:");
      	gtk_container_border_width (GTK_CONTAINER (frame), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, TRUE, 0);
      	gtk_widget_show(frame);
      	
      	vbox3 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame), vbox3);
        gtk_container_border_width (GTK_CONTAINER (vbox3), 5);
        gtk_widget_show (vbox3);
        
        enable_top_check = gtk_check_button_new_with_label("Enable stats status bar");
        gtk_box_pack_start (GTK_BOX (vbox3), enable_top_check, FALSE, TRUE, 0);
        if (top_enable_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_top_check), TRUE);
        gtk_widget_show(enable_top_check);
        
        enable_bottom_check = gtk_check_button_new_with_label("Enable data status bar");
        gtk_box_pack_start (GTK_BOX (vbox3), enable_bottom_check, FALSE, TRUE, 0);
        if (bottom_enable_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_bottom_check), TRUE);
        gtk_widget_show(enable_bottom_check);
        
        hbox = gtk_hbox_new (FALSE, 10);
        gtk_box_pack_start (GTK_BOX (vbox2), hbox, FALSE, TRUE, 0);
        gtk_container_border_width (GTK_CONTAINER (hbox), 0);
        gtk_widget_show (hbox);
        
        frame2 = gtk_frame_new("Stats Bar Fields:");
      	gtk_container_border_width (GTK_CONTAINER (frame2), 0);
      	gtk_box_pack_start (GTK_BOX (hbox), frame2, TRUE, TRUE, 0);
      	gtk_widget_show(frame2);
      	
      	vbox4 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame2), vbox4);
        gtk_container_border_width (GTK_CONTAINER (vbox4), 5);
        gtk_widget_show (vbox4);
      	
        enable_ch_check = gtk_check_button_new_with_label("Contract High");
        gtk_box_pack_start (GTK_BOX (vbox4), enable_ch_check, FALSE, TRUE, 0);
        if (contract_high_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_ch_check), TRUE);
        gtk_widget_show(enable_ch_check);
        
        enable_cl_check = gtk_check_button_new_with_label("Contract Low");
        gtk_box_pack_start (GTK_BOX (vbox4), enable_cl_check, FALSE, TRUE, 0);
        if (contract_low_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_cl_check), TRUE);
        gtk_widget_show(enable_cl_check);
        
        enable_ld_check = gtk_check_button_new_with_label("Last Date");
        gtk_box_pack_start (GTK_BOX (vbox4), enable_ld_check, FALSE, TRUE, 0);
        if (last_date_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_ld_check), TRUE);
        gtk_widget_show(enable_ld_check);
        
        enable_lc_check = gtk_check_button_new_with_label("Last Close");
        gtk_box_pack_start (GTK_BOX (vbox4), enable_lc_check, FALSE, TRUE, 0);
        if (last_close_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_lc_check), TRUE);
        gtk_widget_show(enable_lc_check);
        
        enable_nc_check = gtk_check_button_new_with_label("Net Change");
        gtk_box_pack_start (GTK_BOX (vbox4), enable_nc_check, FALSE, TRUE, 0);
        if (net_change_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_nc_check), TRUE);
        gtk_widget_show(enable_nc_check);
        
        frame3 = gtk_frame_new("Data Bar Fields:");
        gtk_box_pack_start (GTK_BOX (hbox), frame3, TRUE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (frame3), 0);
      	gtk_widget_show(frame3);
      	
      	vbox5 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame3), vbox5);
        gtk_container_border_width (GTK_CONTAINER (vbox5), 5);
        gtk_widget_show (vbox5);
      	
        enable_date_check = gtk_check_button_new_with_label("Date");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_date_check, FALSE, TRUE, 0);
        if (date_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_date_check), TRUE);
        gtk_widget_show(enable_date_check);
        
        enable_open_check = gtk_check_button_new_with_label("Open");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_open_check, FALSE, TRUE, 0);
        if (open_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_open_check), TRUE);
        gtk_widget_show(enable_open_check);
        
        enable_high_check = gtk_check_button_new_with_label("High");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_high_check, FALSE, TRUE, 0);
        if (high_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_high_check), TRUE);
        gtk_widget_show(enable_high_check);
        
        enable_low_check = gtk_check_button_new_with_label("Low");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_low_check, FALSE, TRUE, 0);
        if (low_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_low_check), TRUE);
        gtk_widget_show(enable_low_check);
        
        enable_close_check = gtk_check_button_new_with_label("Close");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_close_check, FALSE, TRUE, 0);
        if (close_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_close_check), TRUE);
        gtk_widget_show(enable_close_check);
        
        enable_volume_check = gtk_check_button_new_with_label("Volume");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_close_check, FALSE, TRUE, 0);
        if (volume_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_volume_check), TRUE);
        gtk_widget_show(enable_volume_check);
        
        enable_openi_check = gtk_check_button_new_with_label("Open Interest");
        gtk_box_pack_start (GTK_BOX (vbox5), enable_openi_check, FALSE, TRUE, 0);
        if (openi_flag)
        	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(enable_openi_check), TRUE);
        gtk_widget_show(enable_openi_check);
      	
      	label = gtk_label_new("Status Bars");
      	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox2, label);
      	
      	/*** chart page ***/
	
	vbox6 = gtk_vbox_new (FALSE, 10);
        gtk_container_border_width (GTK_CONTAINER (vbox6), 10);
        gtk_widget_show (vbox6);
	      	
      	frame4 = gtk_frame_new("Default data points to load:");
      	gtk_box_pack_start (GTK_BOX (vbox6), frame4, FALSE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (frame4), 0);
      	gtk_widget_show(frame4);
      	
      	hbox2 = gtk_hbox_new (FALSE, 10);
        gtk_container_add (GTK_CONTAINER (frame4), hbox2);
        gtk_container_border_width (GTK_CONTAINER (hbox2), 5);
        gtk_widget_show (hbox2);
        
        bars_value_entry = gtk_entry_new();
        gtk_box_pack_start (GTK_BOX (hbox2), bars_value_entry, TRUE, TRUE, 0);
        sprintf(tstring, "%d", bars);
        gtk_entry_set_text(GTK_ENTRY(bars_value_entry), tstring);
        gtk_widget_show(bars_value_entry);
      	
      	label2 = gtk_label_new("Charts");
      	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vbox6, label2);
      	
      	GTK_WIDGET_SET_FLAGS(ok_button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(ok_button);
      	edit_options_flag = 1;
      	gtk_widget_show(edit_options_window);
}
